// ColorBlotReduction.dll v0.0.01 Copyright(C) 2003 minamina
// Avisynth Plugin - Color blot reduction (YUY2 and YV12 Only)

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef _COLOR_BLOT_REDUCTION_H
#define _COLOR_BLOT_REDUCTION_H

#ifdef _MSC_VER
  #include <crtdbg.h>
#else
  #define _ASSERTE(x) assert(x)
  #include <assert.h>
#endif

#include <windows.h>
#include <memory.h>
#include <math.h>
#include <assert.h>
#pragma warning (push, 3)
//#include <boost/shared_ptr.hpp>
//#include <boost/lexical_cast.hpp>
#include "avisynth.h"
#pragma warning (pop)
//#include "synth.h"

class ColorBlotReduction : public GenericVideoFilter
{
private:
	int m_nCbIntensity;
	int m_nCbThreshold;
	int m_nCrIntensity;
	int m_nCrThreshold;

public:
	static void PluginInit(IScriptEnvironment *env)
	{ env->AddFunction(GetName(), GetParams(), Create, 0); }

	ColorBlotReduction(PClip _child, const int nCbIntensity, const int nCbThreshold, const int nCrIntensity, const int nCrThreshold, IScriptEnvironment* env);

private:
	inline Is8vec8 Proc_YV12_Core(const Is8vec8 mDx, const Is8vec8 &mThreshold, const Is16vec4 &mIntensity);
	void Proc_YV12_HalfLeft(const BYTE *pSrc, BYTE *pDest, const Is8vec8 &mThreshold, const Is16vec4 &mIntensity);
	inline void Proc_YV12_Half(const BYTE *pSrc, BYTE *pDest, const Is8vec8 &mThreshold, const Is16vec4 &mIntensity, const int nX);
	void Proc_YV12_HalfRight(const BYTE *pSrc, BYTE *pDest, const Is8vec8 &mThreshold, const Is16vec4 &mIntensity, const int nX);
	static AVSValue __cdecl Create(AVSValue args, void* /*user_data*/, IScriptEnvironment *env)
	{ return new ColorBlotReduction(args[0].AsClip(), args[1].AsInt(20), args[2].AsInt(20), args[3].AsInt(20), args[4].AsInt(20), env); }
	static const char *GetName() { return "DeBlot"; }
	static const char *GetParams() { return "c[CbIntensity]i[CbThreshold]i[CrIntensity]i[CrThreshold]i"; }

	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment *env);
	PVideoFrame ColorBlotReduction_YUY2(int n, IScriptEnvironment *env);
	PVideoFrame ColorBlotReduction_YV12(int n, IScriptEnvironment *env);
};

#endif // _COLOR_BLOT_REDUCTION_H
