#ifndef IVEC_WRAPPER_H_INCLUDED
#define IVEC_WRAPPER_H_INCLUDED

#include <ivec.h>

#define _m_from_BYTEs(b) (*(__m64*)(b))

inline Is8vec8 sat_adds(const I8vec8 &a, const I8vec8 &b)		{ return _m_paddsb(a,b); }
inline Is8vec8 sat_subs(const I8vec8 &a, const I8vec8 &b)		{ return _m_psubsb(a,b); }
inline Iu8vec8 sat_addu(const I8vec8 &a, const I8vec8 &b)		{ return _m_paddusb(a,b); }
inline Iu8vec8 sat_subu(const I8vec8 &a, const I8vec8 &b)		{ return _m_psubusb(a,b); }
//inline Is8vec8 sat_adds(const I8vec8 &a, const I8vec8 &b)		{ return sat_add((Is8vec8)a,(Is8vec8)b); }
//inline Is8vec8 sat_subs(const I8vec8 &a, const I8vec8 &b)		{ return sat_sub((Is8vec8)a,(Is8vec8)b); }
//inline Iu8vec8 sat_addu(const I8vec8 &a, const I8vec8 &b)		{ return sat_add((Is8vec8)a,(Is8vec8)b); }
//inline Iu8vec8 sat_subu(const I8vec8 &a, const I8vec8 &b)		{ return sat_sub((Is8vec8)a,(Is8vec8)b); }

inline __m64 _mm_setallones_si64() { I8vec8 m; return _m_pcmpeqd(m, m); }

inline Is8vec8 abs(const Is8vec8 &a)
{
	Is8vec8 r0 = a;
	Is8vec8 r1 = a;
	Is8vec8 zero = _mm_setzero_si64();
	r1 = cmplt(r1, zero);
	r0 ^= r1;
	r0 -= r1;
	return r0;
}

#endif // IVEC_WRAPPER_H_INCLUDED
